* Read Outlook contact information into a cursor

#DEFINE olContacts 10
#DEFINE NotesPhrase "RAMS"  && This is the key word/phrase to find in the notes

LOCAL oOutlook, oNameSpace, oContacts, oContact
LOCAL cFirst, cLast, cAddr, cPhone

* Open or attach to an instance of Outlook
oOutlook = CreateObject("Outlook.Application")

* Open the NameSpace object.
oNameSpace = oOutlook.GetNameSpace("MAPI")

* Get Contacts folder
oContacts = oNameSpace.GetDefaultFolder( olContacts )

* Create a cursor to hold contact information
CREATE CURSOR ContactInfo ;
      (cFirstName C(15), cLastName C(20), cPhoneNum C(30), ;
       cEmail1 C(30), cEmail2 C(30), cEmail3 C(30), ;
       cWebsite1 C(50), cWebsite2 C(50))

* Go through contacts
FOR EACH oContact IN oContacts.Items
  WITH oContact
    * Is this contact one we want to keep? We know
    * that by finding the defined NotesPhrase in the
    * .Notes property
    IsOK = NotesPhrase$.Body

    IF IsOK
      * Obtain the basic info
      cFirst = .FirstName
      cLast  = .LastName
      
      cEmail1Address  = .Email1Address      
      cEmail2Address  = .Email2Address
      cEmail3Address  = .Email3Address
     
      cWebPage1 = .BusinessHomePage
      cWebPage2 = .PersonalHomePage
 
      * Find a non-empty telephone number (if possible)
      IF EMPTY(.PrimaryTelephoneNumber)
        IF EMPTY(.BusinessTelephoneNumber)
          cPhone = .HomeTelephoneNumber
        ELSE
          cPhone = .BusinessTelephoneNumber
        ENDIF
      ELSE 
        cPhone   = .PrimaryTelephoneNumber
      ENDIF

      * Put it into the cursor
      INSERT INTO ContactInfo ;
                 (cFirstName, cLastName, cPhoneNum, ;
                  cEmail1, cEmail2, cEmail3, ;
                  cWebSite1, cWebSite2) ;
          VALUES (cFirst, cLast, cPhone, ;
                  cEmail1Address, cEmail2Address, cEmail3Address, ;
                  cWebPage1, cWebPage2)
    ENDIF && IsOK

  ENDWITH
ENDFOR

* For this example, display the results in a BROWSE.
* You'll undoubtedly add something more useful in your application.
BROWSE

RETURN

