* name:			sample2.prg
* description:	Adds an order (header + details) to SQL Server
*				Northwind database. Be aware that the added 
*				order _has_ some inconsistent data on it.
*
*				This sample uses VFP transactions only so, 
*				at the end, the order header will be added
*				to the backend but not the order details!
*
* author:		May/2000 - Hector Correa
* updated: 		

* Open VFP database.
? 'Sample2 starts'
open database MyVfpDBC
cursorsetprop( 'buffering', 5, 0 )	&& enable table buffer
use rv_MyView in 0 nodata
use rv_MyOtherView in 0 nodata

* Add order header.
select rv_MyView			
append blank
replace CustomerID with 'GREAL'	&& Great Lakes Food Market
replace EmployeeID with 1
replace ShippedDate with {^2000-12-31}
replace ShipCity with 'Metropolis'

* Add 2 lines for order detail 
* one is valid and the other
* is invalid
select rv_MyOtherView
append blank
replace ProductID with 40 && Boston Crab Meat
replace Quantity with 2

append blank
replace ProductID with -100 && Invalid product ID
replace Quantity with 3

* start VFP and SQL Server transactions
? '   Start transaction'
begin transaction

* Send order + details to SQL Server.
lOkView = tableupdate( 2, .F., 'rv_MyView' )
if lOkView
	lOkOtherView = tableupdate( 2, .F., 'rv_MyOtherView' )	
endif

? '      rv_MyView was ' + iif( lOkView, 'saved', 'not saved' )
? '      rv_MyOtherView was ' + iif( lOkOtherView, 'saved', 'not saved' )

if lOkView and lOkOtherView
	end transaction
	? '   Transaction was commited in VFP (but not in SQL Server!)'
else
	rollback
	? '   Transaction was rolled back in VFP (but not in SQL Server!)'
endif
	
* Close everything.
use in rv_MyView
use in rv_MyOtherView
close database 
? 'Sample2 ends'
? ''

* eof() sample2.prg